--------------------------------------------------------------------------------
-- mod p division. Plus-minus algorithm
--------------------------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.my_package.all;

entity divider_plus_minus is
port (
  x, y: in std_logic_vector(N downto 0);
  clk, reset, start: in std_logic;
  done: out std_logic;
  z: out std_logic_vector(N-1 downto 0)
);
end divider_plus_minus;

architecture circuit of divider_plus_minus is

  component data_path
  port (
  x, y: in std_logic_vector(n downto 0);
  clk, reset: in std_logic; 
  first_step, last_step, ce_a, ce_b, ce_u, ce_v, ce_d, ce_p: in std_logic;
  cont_a: in std_logic_vector(2 downto 0);
  --cont_u: in std_logic_vector(5 downto 0);
  cont_d, cont_p: in std_logic_vector(1 downto 0);
  z: out std_logic_vector(n-1 downto 0);
  p_gt_0, d_equ_0, d_equ_1, sign_d, sign_b, sign_v: out std_logic;
  a_mod_4, u_mod_4: inout std_logic_vector(1 downto 0);
  a_plus_b, u_plus_v, u_minus_v: out std_logic_vector(1 downto 0);
  ce_pre: in std_logic
  );
  end component;

  component control
  port (
  clk, reset,start: in std_logic;
  p_gt_0, d_equ_0, d_equ_1, sign_d, sign_b, sign_v: in std_logic;
  a_mod_4, u_mod_4, a_plus_b, u_plus_v, u_minus_v: in std_logic_vector(1 downto 0);
  first_step, last_step, ce_a, ce_b, ce_u, ce_v, ce_d, ce_p: out std_logic;
  cont_a: out std_logic_vector(2 downto 0);
  cont_u: out std_logic_vector(5 downto 0);
  cont_d, cont_p: out std_logic_vector(1 downto 0);
  ce_pre: out std_logic;
  done: out std_logic
  );
  end component;

  signal first_step, last_step, ce_a, ce_b, ce_u, ce_v, ce_d, ce_p: std_logic;
  signal cont_a: std_logic_vector(2 downto 0);
  signal cont_u: std_logic_vector(5 downto 0);
  signal cont_d, cont_p: std_logic_vector(1 downto 0);
  signal p_gt_0, d_equ_0, d_equ_1, sign_d, sign_b, sign_v: std_logic;
  signal a_mod_4, u_mod_4: std_logic_vector(1 downto 0);
  signal a_plus_b, u_plus_v, u_minus_v: std_logic_vector(1 downto 0);
  signal ce_pre: std_logic;

begin

data_path_block: data_path port map (
x, y, clk, reset, first_step, last_step, ce_a, ce_b, ce_u, ce_v, ce_d, ce_p, 
cont_a, cont_d, cont_p, z, p_gt_0, d_equ_0, d_equ_1, sign_d, sign_b, 
sign_v, a_mod_4, u_mod_4, a_plus_b, u_plus_v, u_minus_v, ce_pre);

control_unit: control port map (
clk, reset,start, p_gt_0, d_equ_0, d_equ_1, sign_d, sign_b, sign_v, a_mod_4, 
u_mod_4, a_plus_b, u_plus_v, u_minus_v, first_step, last_step, ce_a, ce_b, 
ce_u, ce_v, ce_d, ce_p, cont_a, cont_u, cont_d, cont_p, ce_pre, done);

end circuit;