--------------------------------------------------------
-- 
--------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.my_package.all;
library UNISIM;
use UNISIM.ALL;


entity s_r_mux_cell is
    port (
        s: in STD_LOGIC_VECTOR (N+1 downto 0);
        srn: in STD_LOGIC_VECTOR(1 downto 0);
		  res: out STD_LOGIC_VECTOR (N+2 downto 0)
     );
end s_r_mux_cell;

architecture s_r_mux_arch of s_r_mux_cell is

begin

adder_subt_mux: process (srn,s)
begin
      case srn is
         when "00" => res <= s(N+1) & s;
			when "01" => res <= (s(N+1) & s) + (module & '0');
         when "10" => res <= (s(N+1) & s) + module;
         when "11" => res <= (s(N+1) & s) - module;
         when others => res <= (others => '0');
      end case;
end process;

end s_r_mux_arch;


architecture low_level of s_r_mux_cell is

component LUT3
  generic (INIT : bit_vector(7 downto 0));
  port (I0 : in std_logic;  I1 : in std_logic; I2 : in std_logic; O : out std_logic );
end component;
 
component MUXCY
  port ( DI : in std_logic; CI : in std_logic;  S : in std_logic; O : out std_logic );
end component;

component XORCY
 port ( CI : in std_logic; LI : in std_logic; O : out std_logic );
end component;

signal lut_out,carry_logic: std_logic_vector(N+3 downto 0);
begin

	 carry_logic(0) <= '0';

   iterac: for I in 0 to N+1 generate
				the_xor: LUT3 generic map(init => init_lut(i)) 
								  port map (I0 => s(i), I1 => srn(0),I2 => srn(1), O => lut_out(i));
				the_muxcy: MUXCY port map(DI => s(i) , CI =>carry_logic(i), S => lut_out(i), O => carry_logic(i+1));
				the_xorcy: XORCY port map(CI =>carry_logic(i), LI =>lut_out(i), O => res(i) );
		end generate;
		-- Paso N+2
		the_xor: LUT3 generic map(init => init_lut(N+2)) 
						  port map (I0 => s(N+1), I1 => srn(0),I2 => srn(1), O => lut_out(N+2));
		the_muxcy: MUXCY port map(DI => s(N+1) , CI =>carry_logic(N+2), S => lut_out(N+2), O => carry_logic(N+3));
		the_xorcy: XORCY port map(CI =>carry_logic(N+2), LI =>lut_out(N+2), O => res(N+2) );
 end low_level;